using System.Collections.Generic;
using FT.Architecture.Logging;
using FT.Architecture.NHibernate.Repositories;
using FT.Architecture.NHibernate.SessionManagement;
using FT.Architecture.Queries;
using NHibernate.Criterion;

namespace $rootnamespace$.Repositories
{
    public class MyEntityRepository : NHibernateRepository<MyEntity>, IMyEntityRepository
    {
        public MyEntityRepository(ISessionProviderService sessionProvider, IQueryExecutorService queryExecutor, ILogService logService) : base(sessionProvider, queryExecutor, logService)
        {
        }
		
		public IList<MyEntity> Search(string search)
        {
            return SessionProvider.GetSession().QueryOver<MyEntity>()
                                  .WhereRestrictionOn(x => x.Name).IsLike(search, MatchMode.Anywhere)
                                  .List();
        }
    }
}
