﻿#region Copyright
//       Copyright (c) 2009 - Antoine Jaussoin - http://www.jaussoin.com/blog/
// 
//        This program is free software: you can redistribute it and/or modify
//        it under the terms of the GNU General Public License as published by
//        the Free Software Foundation, either version 3 of the License, or
//        (at your option) any later version.
// 
//        This program is distributed in the hope that it will be useful,
//        but WITHOUT ANY WARRANTY; without even the implied warranty of
//        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//        GNU General Public License for more details.
// 
//        You should have received a copy of the GNU General Public License
//        along with this program.  If not, see <http://www.gnu.org/licenses/>.
#endregion
using System.Security.Cryptography;
using System.Text;

namespace FT.Architecture.Utils.Cryptography
{
    /// <summary>
    /// Provides MD5 hashing
    /// </summary>
    public class Md5
    {
        /// <summary>
        /// Hash a string into MD5
        /// </summary>
        /// <param name="stringToHash"></param>
        /// <returns></returns>
        public static string HashString(string stringToHash)
        {
            byte[] data = Encoding.UTF8.GetBytes(stringToHash);
            return HashBytes(data);
        }

        /// <summary>
        /// Provide a MD5 hash of a serialised object
        /// </summary>
        /// <param name="obj"></param>
        /// <returns></returns>
        public static string HashObject(object obj)
        {
            byte[] data = Serialisation.Serialiser.SerialiseBytes(obj);
            return HashBytes(data);
        }

        /// <summary>
        /// Provide a MD5 hash of an array of bytes
        /// </summary>
        /// <param name="bytes"></param>
        /// <returns></returns>
        public static string HashBytes(byte[] bytes)
        {
            var x = new MD5CryptoServiceProvider();
            bytes = x.ComputeHash(bytes);
            string ret = "";
            for (int i = 0; i < bytes.Length; i++)
                ret += bytes[i].ToString("x2").ToLower();
            return ret;
        }
    }
}
