#region Copyright
//       Copyright (c) 2009 - Antoine Jaussoin - http://www.jaussoin.com/blog/
// 
//        This program is free software: you can redistribute it and/or modify
//        it under the terms of the GNU General Public License as published by
//        the Free Software Foundation, either version 3 of the License, or
//        (at your option) any later version.
// 
//        This program is distributed in the hope that it will be useful,
//        but WITHOUT ANY WARRANTY; without even the implied warranty of
//        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//        GNU General Public License for more details.
// 
//        You should have received a copy of the GNU General Public License
//        along with this program.  If not, see <http://www.gnu.org/licenses/>.
#endregion
#region Original Copyright
// This is partially taken from Bill McCafferty S#arp Architecture
#endregion
using System;

namespace FT.Architecture.Entities
{
    /// <summary>
    /// Provides a base class for your objects which will be persisted to the database.
    /// Benefits include the addition of an Id property along with a consistent manner for comparing
    /// entities.
    /// 
    /// Since nearly all of the entities you create will have a type of int Id, this 
    /// base class leverages this assumption.  If you want an entity with a type other 
    /// than int, such as string, then use <see cref="GenericEntity{TId}" /> instead.
    /// </summary>
    [Serializable]
    public abstract class Entity : GenericEntity<long>, IEntity { }
}