#region Copyright
//       Copyright (c) 2009 - Antoine Jaussoin - http://www.jaussoin.com/blog/
// 
//        This program is free software: you can redistribute it and/or modify
//        it under the terms of the GNU General Public License as published by
//        the Free Software Foundation, either version 3 of the License, or
//        (at your option) any later version.
// 
//        This program is distributed in the hope that it will be useful,
//        but WITHOUT ANY WARRANTY; without even the implied warranty of
//        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//        GNU General Public License for more details.
// 
//        You should have received a copy of the GNU General Public License
//        along with this program.  If not, see <http://www.gnu.org/licenses/>.
#endregion

using System;

namespace FT.Architecture.Entities
{
    /// <summary>
    /// This serves as a base interface for <see cref="GenericEntity{TId}"/> and 
    /// <see cref="Entity" />. Also provides a simple means to develop your own base entity.
    /// </summary>
    public interface IGenericEntity<TId> : IEquatable<IGenericEntity<TId>>, IBaseObject
    {
        /// <summary>
        /// Identifier
        /// </summary>
        TId Id { get; set; }

        /// <summary>
        /// Returns <see langword="true"/> if the object is transient
        /// </summary>
        /// <returns></returns>
        bool IsTransient();
    }
}