﻿namespace FT.Architecture.Repositories
{
    /// <summary>
    /// Attach refresh options
    /// </summary>
    public enum AttachMode
    {
        /// <summary>
        /// The database will be updated according to any changes made on the entity
        /// </summary>
        UpdateDatabase,
        /// <summary>
        /// The entity will be updated according to any changes made on the database
        /// </summary>
        UpdateEntity,
        /// <summary>
        /// Neither the entity nor the database will be refreshed
        /// </summary>
        NoUpdate
    }
}