﻿using System.Drawing;
using FT.Architecture.Example.Core.Entities.Humans;

namespace FT.Architecture.Example.Core.Entities.Cars
{
    /// <summary>
    /// Represent a Car
    /// </summary>
    public interface ICar : IGuidEntity
    {
        /// <summary>
        /// Brand of the car
        /// </summary>
        string Brand { get; set; }

        /// <summary>
        /// Year of the car
        /// </summary>
        int Year { get; set; }

        /// <summary>
        /// Plate
        /// </summary>
        string Plate { get; set; }

        /// <summary>
        /// Colour of the car
        /// </summary>
        Color Colour { get; set; }

        /// <summary>
        /// Owner of the car
        /// </summary>
        IHuman Owner { get; set; }
    }
}