#region Copyright
//       Copyright (c) 2009 - Antoine Jaussoin - http://www.jaussoin.com/blog/
// 
//        This program is free software: you can redistribute it and/or modify
//        it under the terms of the GNU General Public License as published by
//        the Free Software Foundation, either version 3 of the License, or
//        (at your option) any later version.
// 
//        This program is distributed in the hope that it will be useful,
//        but WITHOUT ANY WARRANTY; without even the implied warranty of
//        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//        GNU General Public License for more details.
// 
//        You should have received a copy of the GNU General Public License
//        along with this program.  If not, see <http://www.gnu.org/licenses/>.
#endregion
using System.Collections.Generic;

namespace FT.Architecture.Example.Core.Entities.Humans
{
    /// <summary>
    /// Represent a Man
    /// </summary>
    public class Man : HumanBase
    {
        /// <summary>
        /// Constructor
        /// </summary>
        public Man()
        {
        }

        /// <summary>
        /// Constructor with parents
        /// </summary>
        /// <param name="father"></param>
        /// <param name="mother"></param>
        public Man(Man father, Woman mother) : base(father, mother)
        {
        }

        /// <summary>
        /// List of children
        /// </summary>
        public override ICollection<IHuman> Children
        {
            get 
            { 
                if (MarriedTo != null) 
                    return new List<IHuman>(MarriedTo.Children).AsReadOnly(); 
                
                return new List<IHuman>(); 
            }
        }

        /// <summary>
        /// Say something
        /// </summary>
        public override string SaySomething()
        {
            return "I'm a dude, dude";
        }
    }
}
