#region Copyright
//       Copyright (c) 2009 - Antoine Jaussoin - http://www.jaussoin.com/blog/
// 
//        This program is free software: you can redistribute it and/or modify
//        it under the terms of the GNU General Public License as published by
//        the Free Software Foundation, either version 3 of the License, or
//        (at your option) any later version.
// 
//        This program is distributed in the hope that it will be useful,
//        but WITHOUT ANY WARRANTY; without even the implied warranty of
//        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//        GNU General Public License for more details.
// 
//        You should have received a copy of the GNU General Public License
//        along with this program.  If not, see <http://www.gnu.org/licenses/>.
#endregion
namespace FT.Architecture.Example.Core.Entities.Humans
{
    /// <summary>
    /// Represents a Woman
    /// </summary>
    public class Woman : HumanBase
    {
        private int lengthOfHairs;

        /// <summary>
        /// Constructor
        /// </summary>
        public Woman()
        {
        }

        /// <summary>
        /// Constructor with parents
        /// </summary>
        /// <param name="father"></param>
        /// <param name="mother"></param>
        public Woman(Man father, Woman mother) : base(father, mother)
        {
        }

        /// <summary>
        /// Say something
        /// </summary>
        public override string SaySomething()
        {
            return "I'm a girl, lady";
        }

        /// <summary>
        /// Length, in centimeters, of a woman hairs
        /// </summary>
        public virtual int LengthOfHairs
        {
            get { return lengthOfHairs; }
            set { lengthOfHairs = value; }
        }
    }
}
