#region Copyright
//       Copyright (c) 2009 - Antoine Jaussoin - http://www.jaussoin.com/blog/
// 
//        This program is free software: you can redistribute it and/or modify
//        it under the terms of the GNU General Public License as published by
//        the Free Software Foundation, either version 3 of the License, or
//        (at your option) any later version.
// 
//        This program is distributed in the hope that it will be useful,
//        but WITHOUT ANY WARRANTY; without even the implied warranty of
//        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//        GNU General Public License for more details.
// 
//        You should have received a copy of the GNU General Public License
//        along with this program.  If not, see <http://www.gnu.org/licenses/>.
#endregion
using System.Collections.Generic;
using FT.Architecture.Repositories;
using FT.Architecture.Example.Core.Entities.Humans;

namespace FT.Architecture.Example.Core.Repositories
{
    /// <summary>
    /// DAL for <see cref="IHuman"/> entities
    /// </summary>
    public interface IHumanRepository : IRepository<IHuman>
    {
        /// <summary>
        /// Gets all the humans under 18 years old of age
        /// </summary>
        /// <returns></returns>
        IList<IHuman> GetUnderAgeHumans();

        IList<IHuman> GetHumansOrderedByNameThenTelephone();
    }
}
