#region Copyright
//       Copyright (c) 2009 - Antoine Jaussoin - http://www.jaussoin.com/blog/
// 
//        This program is free software: you can redistribute it and/or modify
//        it under the terms of the GNU General Public License as published by
//        the Free Software Foundation, either version 3 of the License, or
//        (at your option) any later version.
// 
//        This program is distributed in the hope that it will be useful,
//        but WITHOUT ANY WARRANTY; without even the implied warranty of
//        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//        GNU General Public License for more details.
// 
//        You should have received a copy of the GNU General Public License
//        along with this program.  If not, see <http://www.gnu.org/licenses/>.
#endregion
using System.Collections.Generic;
using FT.Architecture.Example.Core.Repositories;
using FT.Architecture.Example.Core.Entities.Humans;
using FT.Architecture.Logging;
using FT.Architecture.NHibernate.Repositories;
using FT.Architecture.NHibernate.SessionManagement;
using FT.Architecture.Queries;

namespace FT.Architecture.Example.Data.Repositories
{
    /// <summary>
    /// Implementation of <see cref="ISupermanRepository"/> using <see cref="NHibernate"/>
    /// </summary>
    public class NHibernateSupermanRepository : NHibernateRepository<Superman>, ISupermanRepository 
    {
        public NHibernateSupermanRepository(ISessionProviderService sessionProvider, IQueryExecutorService queryExecutor, ILogService logService) : base(sessionProvider, queryExecutor, logService)
        {
        }

        /// <summary>
        /// Gets all the supermen whose the Father property is of type Superman
        /// </summary>
        /// <returns></returns>
        public IList<Superman> GetAllSupermenWhoseFatherWasSuperman()
        {
            return SessionProvider.GetSession().CreateQuery("from Superman s where s.Father.class = 'Superman'")
                .List<Superman>();
        }
    }
}
