﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using FT.Architecture.Example.Core.Entities.Humans;
using FT.Architecture.NHibernate.Context;
using FT.Architecture.NHibernate.Factories;
using FT.Architecture.NHibernate.Repositories;
using FT.Architecture.NHibernate.SessionManagement;
using NUnit.Framework;

namespace FT.Architecture.Tests.Architecture
{
    [TestFixture]
    public class AccessFromDifferentThreadsTests : BaseTest
    {
        public class When_Accessing_A_Unit_Of_Work_From_A_Different_Thread : AccessFromDifferentThreadsTests
        {
            [Test]
            public void It_Should_Not_Fail()
            {
                unitOfWork.Start();
                var count = humanRepository.GetCount();
                unitOfWork.Commit();

                var anotherThread = new Thread(AnotherThread);

                anotherThread.Start();
                anotherThread.Join();
            }

            private void AnotherThread()
            {
                //var sessionProviderService2 = new SessionProviderService("Thread Session");
                //var unitOfWork2 = new NHibernateUnitOfWork(sessionProviderService2, new XmlMappingNHibernateConfigurator());
                //var manRepository2 = new NHibernateRepository<Man>(sessionProviderService2, null, logService);

                //unitOfWork2.Start();
                unitOfWork.Start();
                var count = manRepository.GetCount();
                Assert.That(count, Is.Not.EqualTo(0));
                unitOfWork.Commit();

                //unitOfWork2.Commit();
            }
        }
    }
}
