﻿using FT.Architecture.Utils.Cryptography;
using NUnit.Framework;

namespace FT.Architecture.Tests.Utils
{
    public class CryptographyTests : BaseTest
    {
        [TestFixture]
        public class When_Hashing_A_String : CryptographyTests
        {
            [Test]
            public void An_Hashed_String_Should_Return_The_Correct_Result()
            {
                // Arrange
                const string testString = "Hello World!";
                const string supposedResult = "ed076287532e86365e841e92bfc50d8c"; //http://www.miraclesalad.com/webtools/md5.php

                // Act
                var result = Md5.HashString(testString);
                
                // Assert
                Assert.That(result, Is.EqualTo(supposedResult));
            }

            [Test]
            public void An_Hashed_Object_Should_Return_The_Correct_Result()
            {
                // Arrange
                const string testString = "Hello World!";
                const string supposedResult = "f7c39832946c4e8dba994ec30d374d91";

                // Act
                var result = Md5.HashObject(testString);

                // Assert
                Assert.That(result, Is.EqualTo(supposedResult));
            }
        }
    }
}
