﻿#region Copyright
//       Copyright (c) 2009 - Antoine Jaussoin - http://www.jaussoin.com/blog/
// 
//        This program is free software: you can redistribute it and/or modify
//        it under the terms of the GNU General Public License as published by
//        the Free Software Foundation, either version 3 of the License, or
//        (at your option) any later version.
// 
//        This program is distributed in the hope that it will be useful,
//        but WITHOUT ANY WARRANTY; without even the implied warranty of
//        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//        GNU General Public License for more details.
// 
//        You should have received a copy of the GNU General Public License
//        along with this program.  If not, see <http://www.gnu.org/licenses/>.
#endregion
using System;
using System.Collections.Generic;
using System.Threading;
using FT.Architecture.Utils.Math;
using NUnit.Framework;

namespace FT.Architecture.Tests.Utils
{
    [TestFixture]
    public class RandomFactoryTest
    {
        [Test]
        public void TestingThreadSafety()
        {
            IList<Thread> threads = new List<Thread>();

            for (int i = 0; i < 100; i++)
            {
                Thread thread = new Thread(Thread);
                threads.Add(thread);
                thread.Start();
            }

            foreach (var thread in threads)
            {
                thread.Join();
            }
        }

        private void Thread()
        {
            try
            {
                for (int i = 0; i < 1000; i++)
                {
                    int random = RandomFactory.Instance.Next(0, 100);
                    System.Threading.Thread.Sleep(new TimeSpan(100));
                }
            }
            catch(Exception ex)
            {
                Assert.Fail("Something went wrong : "+ex);
            }
        }
    }
}
